#--------------------------------------------------------------
#
#              INTERRUPT DRIVEN LED
#	       ====================
#
# In this program and LED is connected to port GPIO0 and a button
# is connected to port GPIO2. GPIO0 is configures as an output and
# GPIO2 is configured as an input. When the button is pressed an
# interrupt occurs and function LED is called to turn the LED ON.
# The interrupt is recognized when the button is pressed. i.e.
# port GPIO2 goes from logic 1 to logic 0 (falling edge)
#
#
# Program : 	ledbutton.py
# Date    : 	April, 2017
# Programmer: 	Dogan Ibrahim
#---------------------------------------------------------------
from machine import Pin

GPIO = 0
GPIO2 = 2
ON = 1
OFF = 0

def LED():
   p0.value(ON)
   return

p0 = Pin(GPIO, Pin.OUT)   			# GPIO is output
p2 = Pin(GPIO2, Pin.IN, Pin.PULL_UP)		# GPIO2 is input
p0.value(OFF)					# LED OFF
p2.irq(handler=LED, trigger = Pin.IRQ_FALLING)

# Wait here forever for the interrupt to occur
while True:
   Pass

   