#------------------------------------------------------------------
#
#              		UART - LCD
#	       		==========
#
# In this program a serial LCD is conencted to the TX1 pin of the
# NodeMCU (pin D4). The program uses the UART to perform the 
# following LCD operations in functions:
#
#  LCD_Clear()
#  LCD_Position(row, column)
#  LCD_Write_Text(text)
#
# The following are performed:
#  Clear the LCD
#  Go to row=1, column =1
#  Write text message "Computer"
#
# The UART is set to operate at 9600 baud which is the default baud
# rate of the LCD
#
# Program : 	uart.py
# Date    : 	April, 2017
# Programmer: 	Dogan Ibrahim
#------------------------------------------------------------------
from machine import UART

uart = UART(1, 9600)

#
# The following function clears the LCD
#
def LCD_Clear():
   uart.write(bytes([0xFE]))
   uart.write(bytes([0x01]))
   
#
# The following function positions teh LCD at given row,column
#
def LCD_Position(row, column):
   uart.write(bytes([0xFE]))
   r = col + row*64 + 128
   uart.write(bytes([r]))

#
# The following function writes the specified text to the LCD
#
def LCD_Write_Text(text):
   uart.write(text)

#
# Now we can clear the LCD, position to row,col=1 and write text
#
LCD_Clear()
LCD_Position(1, 1)
LcD_Write_Text("Computer")









   

   