#-----------------------------------------------------------------------------
#              			WHAT TO WEAR
#	       			============
#
# This project gets teh local weather forecast and tells the user what
# to wear depending upon the weather forecast.
#
# An EMIC2 Text-to_Speech processor module is connected to the NodeMCU
# development board. In addition, a small 8 ohms speaker is connected
# to the EMIC2 module. The programs gets the local weather forecast and
# suggests the user what clother to wear for the day depending upon the
# local weather forecast.
#
# The local weather dta is received from the "Wunderground" application.
# Although this is a payable service, it can be used free of charge with
# some limitations. The city where the weather forecast is required must
# be supplied to the service. The service returns the weather forecast
# after making an HTTP GET request. The returned data is in JSON text
# format.
#
# In this project the "conditions" parameter of wundeground is used.
#
#
# Program : 	weather.py
# Date    : 	April, 2017
# Programmer: 	Dogan Ibrahim
#------------------------------------------------------------------------------
import network
import socket
from machine import UART
import time
#
# Send an introductory message
#
uart = UART(1, 9600)
uart.write("V15"+chr(13))		# Increase the volume
uart.write("SGood Morning."+chr(13))
time.sleep(5)
uart.write("SThis is your weather forecast for today."+chr(13))
sleep(3)

Url = "api.wunderground.com"
global weather_data

#
# This function connect to the Wi-Fi
#
def Connect_WiFi():
    net = network.WLAN(network.STA_IF)
    if not net.isconnected():
       net.active(True)
       net.connect(BTHub5-6SPN, af4b5e6243)
       print(net.ifconfig())

#
# This function sends an HTTP GET request to get the weather data
#
def HTTP_GET_WEATHER(Url):
   global weather_data
   addr = socket.getaddrinfo(Url, 80)[0][-1]
   sock = socket.socket()
   sock.connect(addr)
   path = "api/5da3f29f6bad56fc/conditions/q/UK/London.json"
   host = "api.wunderground.com"
   sock.send(bytes("GET /%s HTTP/1.0\r\nHost: %s\r\n\r\n" %(path,host),"utf8"))
   weather_data=""
   dat = ""
   while True:
      dat = sock.recv(1024)
      if dat:
          weather_data = weather_data + str(dat)
      else:
          break
   sock.close()

#
# This function extracts data from the weather report
#
def Extract_Data(itm, mode):
   global weather_data
   param1 = weather_data.find(itm)
   colon = weather_data.find(":", param1)
   comma=weather_data.find(",", colon)
   dat = weather_data[colon+1+mode:comma-mode]
   return dat

#
# Connect to the Wi-Fi, get weather data, and extract the weather parameters 
#
Connect_WiFi()
HTTP_GET_WEATHER(url)
wind = Extract_Data("wind_kph", 0)
visibility = Extract_Data("visibility_km", 1)
temp = Extract_Data("feelslike_c", 1)
weather=Extract_Data("weather\"",1)
prec = Extract_Data("precip_today_metric", 1)
if str(prec) == "--":
   prec = "NO"
else:
   prec = ""

#
# Now tell the weather and make a sugegstion on what to wear
#
uart.write("SThe Wind speed is"+str(wind)+"kilometres per hour."+chr(13))
time.sleep(6)
uart.write("SThe visibility is"+str(visibility)+"kilometres."+chr(13))
time.sleep(6)
uart.write("SThe temperature is"+str(temp)+"degrees centigrade."+chr(13))
time.sleep(6)
uart.write("SThere is"+prec+"precipitation."+chr(13))
time.sleep(6)
uart.write("Sthe weather is"+str(weather)+"."+chr(13))
time.sleep(6)

if temp < 15:
   outlook1 = "The weather is cold you should wear thick clothes."
else:
   outlook1 = "The weather is warm you should not wear thick clothes." 

if prec != "NO":
   outlook2 = "There is rain and you should take your umbrella."
else:
   outlook2 = "There is no rain today."

uart.write("S"+outlook1+chr(13))
time.sleep(6)
uart.write("S"+outlook2+chr(13))
time.sleep(6)
uart.write("SHave a nice day."+chr(13))

   
















   

   