#-----------------------------------------------------------------------------
#              		WEB SERVER TO CONTROL 2 LEDs
#	       		============================
#
# This is a simple web server program. 2 LEDs are conencted to ports GPIO0 and
# GPIO2 of the NodeMCU development board. The project controls these LEDs
# (turns ON or OFF) from a web server application. For example, the LEDs can be
# controlled from any device that is on the web, for example a PC, tablet,
# mobile phone etc. When activated, a form will appear on the device with
# buttons and clicking these button will control the LEDs.The LEDs are named as
# LED0 and LED2, conencte dto ports GPIO0 and GPIO2 respectively.
#
# Notice that GIO0 corrsponds to pin D3 nd GPIO2 corresponds to pin D4 on the
# NodeMCU pin layout.
#
#
#
# Program : 	webserver.py
# Date    : 	May, 2017
# Programmer: 	Dogan Ibrahim
#------------------------------------------------------------------------------
import network
import socket
from machine import Pin
#
# Configure the pins as outputs
#
LED0 = Pin(0, Pin.OUT)
LED2 = Pin(2, Pin.OUT)
#
# Turn OFF the LEDs to start with
#
LED0.low()
LED2.low()

#
# The HTML code
#
html = """<!DOCTYPE html>
<html>
<body>
<center><h1>NodeMCU LED ON/OFF</h1></center>
<center><h2>MicroPython Web Server Example with 2 LEDs</h2></center>
<form>

<button name="LED0" button style="color:green" value="ON" type="submit">LED0 ON</button>
<button name="LED0" button style="color=red" value="OFF" type="submit">LED0 OFF</button><br><br>

<button name="LED2" button style="color:green" value="ON" type="submit">LED2 ON</button>
<button name="LED2" button style="color:red" value="OFF" type="submit">LED2 OFF</button>
</form>
</body>
</html>
"""


#
# This function connects to the Wi-Fi
#
def Connect_WiFi():
    net = network.WLAN(network.STA_IF)
    if not net.isconnected():
       net.active(True)
       net.connect(BTHub5-6SPN, af4b5e6243)
       print(net.ifconfig())

#
# 
#
Connect_WiFi()
addr=socket.getaddrinfo("0.0.0.0",80)[0][-1]
s = socket.socket()
s.bind(addr)
s.listen(1)
while True:
    conn, address = s.accept()
    request = conn.recv(1024)
    request = str(request)
    LEDON0 = request.find("/?LED0=ON")
    LEDOFF0 = request.find("/?LED0=OFF")
    LEDON2 = request.find("/?LED2=ON")
    LEDOFF2 = request.find("/?LED2=OFF")
    if LEDON0 != -1:
        LED0.high()
    if LEDOFF0 != -1:
        LED0.low()
    if LEDON2 != -1:
        LED2.high()
    if LEDOFF2 != -1:
        LED2.low()
    resp = html
    conn.send(resp)
    conn.close()

   
















   

   